# Camera OrbitOnTarget 1.0   2008.11.14   by   Marcio de A. Braga
# 
require 'sketchup.rb'
include Math

class Test1

def initialize
	@ip1 = nil
	@vetorZ=Geom::Vector3d.new(0.0, 0.0, 1.0)
	@msg1="Center and Target Lock: Double-click [or] Rotate: LButton+drag [or] Zoom: Shift+LButton+drag [or] Pan: Ctrl+LButton+drag"
	end

def activate
	Sketchup.set_status_text(@msg1, SB_PROMPT)
	@xant=0.0
	@yant=0.0
	@camera = Sketchup.active_model.active_view.camera
	@ip1 = Sketchup::InputPoint.new
	if $mama_target == nil then
		@target=@camera.target
	else
		@target=$mama_target
	end
	reView
	end

def deactivate(view)
	$mama_target=@target
	end

def onLButtonDown(flags, x, y, view)
	Sketchup.set_status_text(@msg1, SB_PROMPT)
	end

def onLButtonDoubleClick(flags, x, y, view)
	# 0=none / 1=Left / 2=Right / 4=Shift / 8=Ctrl / 16=??? / 32=Alt  / Alt Gr = alt + ctrl
	@ip1.pick(view, x, y)
	if( @ip1.valid? )
		@target=@ip1.position
		reView
	end
	end

def onMouseMove(flags, x, y, view)
	# 0=none / 1=Left / 2=Right / 4=Shift / 8=Ctrl / 16=??? / 32=Alt  / Alt Gr = alt + ctrl
	#p flags
	if flags==0 then
		@ip1.pick(view, x, y)
		view.invalidate if( @ip1.display? )
	elsif flags==1 then # Move with LButton down
		e1=@camera.eye
		if x != @xant then # Horiz plane rotation
			if x>@xant then kk=-0.005 else kk=0.005 end
			bb=(x-@xant).abs
			if bb>5.0 then bb=5.0 end
			deltaH=kk*bb
			@xant=x
			transf1 = Geom::Transformation.rotation(@target, @vetorZ, deltaH)
			e1.transform!(transf1) # Move Eye com Rotacao em torno de Z e centro em T
			@vetorH.transform!(transf1)
			@vetorT.transform!(transf1)
			@center.transform!(transf1) # Move C com Rotacao em torno de Z e centro em T
		end
		if y != @yant then # Vert plane rotation
			if y>@yant then kk=0.005 else kk=-0.005 end
			bb=(y-@yant).abs
			if bb>5.0 then bb=5.0 end
			deltaV=kk*bb
			@yant=y
			vetorN=Geom::Vector3d.new(@vetorH.y,-1.0*@vetorH.x,0)
			transf2 = Geom::Transformation.rotation(@target, vetorN, deltaV)
			e1.transform!(transf2) # transf Vert do Eye
			@vetorT.transform!(transf2)
			@center.transform!(transf2) # Move C com Rotacao em torno da Normal ao Plano Vertical e centro em T
		end
		@camera.set(e1,@center,@vetorT)
	elsif	flags==5 then
		if y != @yant then
			if y>@yant then kk=-1.0 else kk=1.0 end
			bb=(y-@yant).abs
			if bb>5.0 then bb=5.0 end
			pp=kk*bb/100.0
			e1=Geom::Point3d.linear_combination((1.0-pp),@camera.eye,pp, @target)
			@center=Geom::Point3d.linear_combination((1.0-pp),@camera.target, pp, @target)
			@yant=y
			@camera.set(e1,@center,@camera.up)
		end
	elsif flags==9 then
		if y != @yant then
			e1=@camera.eye
			rx=@center.x-e1.x
			ry=@center.y-e1.y
			if y>@yant then kk=0.01 else kk=-0.01 end
			e1.x=e1.x+kk*rx
			e1.y=e1.y+kk*ry
			@center.x=@center.x+kk*rx
			@center.y=@center.y+kk*ry
			@yant=y
			@camera.set(e1,@center,@vetorT)
		end
		if x != @xant then
			e1=@camera.eye
			rx=@center.x-e1.x
			ry=@center.y-e1.y
			if x>@xant then kk=0.01 else kk=-0.01 end
			e1.x=e1.x-kk*ry
			e1.y=e1.y+kk*rx
			@center.x=@center.x-kk*ry
			@center.y=@center.y+kk*rx
			@xant=x
			@camera.set(e1,@center,@vetorT)
		end
	end
	end # onMouseMove

def draw(view)
	@ip1.draw(view)
	end

def reView
	@center=@target.clone
	@vetorH=Geom::Vector3d.new(@camera.eye.x-@target.x,@camera.eye.y-@target.y,0.0)
	angV=Math.asin((@camera.eye.z-@target.z)/@camera.eye.distance(@target))+0.5*Math::PI
	vetorN=Geom::Vector3d.new(@vetorH.y,-1.0*@vetorH.x,0)
	@vetorT=@vetorH.transform(Geom::Transformation.rotation(@target, vetorN, angV))
	@camera.set(@camera.eye,@target,@vetorT)
	end
	
def resume(view)
	Sketchup.set_status_text(@msg1, SB_PROMPT)
	@target=@camera.target
	reView
	end

end # class Test1

def t1
	myTool=Sketchup.active_model.select_tool(Test1.new)
	end

if not file_loaded?("CamOOT.rb")
	cmd = UI::Command.new("Mama11") { t1 }
	cmd.small_icon = "OOT_icons/Cam_OOT_16.png"
	cmd.large_icon = "OOT_icons/Cam_OOT_24.png"
	cmd.menu_text = "Mama menu text"

	cmd.tooltip = "Camera OrbitOnTarget: Rotate, Zoom, Pan"
	cmd.status_bar_text = "Camera OrbitOnTarget: Center, Rotate, Zoom, Pan the view Camera around a Target"
	mamaBar = UI::Toolbar.new("MamaTools")
	mamaBar.add_item(cmd)

	mamaMenu = UI.menu("Plugins")
	mamaSubMenu = mamaMenu.add_submenu("MamaMenus")
	mamaSubMenu.add_item("t1") { t1 }
end
file_loaded("CamOOT.rb")