# Component OrbitOnTarget 1.0   2008.11.16   by   Marcio de A. Braga
# 
require 'sketchup.rb'
include Math

class Test2

def initialize
	@vetorZ=Geom::Vector3d.new(0.0, 0.0, 1.0)
	@msg1="[first] Select Reference: Double-click [then] Select Target: Double-click [then] Rotate: LButton+drag [or] Distance: Shift+LButton+drag"
	end

def activate
	@model = Sketchup.active_model
	@sels = @model.selection
	check=0
	@sels.each do |i|
		check=check+1 if i.typename == "ComponentInstance"
	end
	p "nada" if check==0
	Sketchup.set_status_text(@msg1, SB_PROMPT)
	@xant=0.0
	@yant=0.0
	@ip1 = Sketchup::InputPoint.new
	@orig = nil
	@target= nil
	end

def deactivate(view)
	end

def onLButtonDown(flags, x, y, view)
	Sketchup.set_status_text(@msg1, SB_PROMPT)
	end

def onLButtonDoubleClick(flags, x, y, view)
	# 0=none / 1=Left / 2=Right / 4=Shift / 8=Ctrl / 16=??? / 32=Alt  / Alt Gr = alt + ctrl
	@ip1.pick(view, x, y)
	if( @ip1.valid? )
		if @orig == nil then
			@orig=@ip1.position
		else
			@target=@ip1.position
			@vetorH=Geom::Vector3d.new(@orig.x-@target.x,@orig.y-@target.y,0.0)
		end
	end
	end

def onMouseMove(flags, x, y, view)
	# 0=none / 1=Left / 2=Right / 4=Shift / 8=Ctrl / 16=??? / 32=Alt  / Alt Gr = alt + ctrl
	#p flags
	if flags==0 then
		@ip1.pick(view, x, y)
		view.invalidate if( @ip1.display? )
	elsif flags==1 then # Move with LButton down
		if x != @xant then # Horiz plane rotation
			if x>@xant then kk=0.005 else kk=-0.005 end
			bb=(x-@xant).abs
			if bb>5.0 then bb=5.0 end
			deltaH=kk*bb
			@xant=x
			transf1 = Geom::Transformation.rotation(@target, @vetorZ, deltaH)
			@vetorH.transform!(transf1)
			@orig.transform!(transf1)
			@sels.each do |i|
				i.transform!(transf1) if i.typename == "ComponentInstance"
			end
		end
		if y != @yant then # Vert plane rotation
			if y>@yant then kk=-0.005 else kk=0.005 end
			bb=(y-@yant).abs
			if bb>5.0 then bb=5.0 end
			deltaV=kk*bb
			@yant=y
			vetorN=Geom::Vector3d.new(@vetorH.y,-1.0*@vetorH.x,0)
			transf2 = Geom::Transformation.rotation(@target, vetorN, deltaV)
			@orig.transform!(transf2)
			@sels.each do |i|
				i.transform!(transf2) if i.typename == "ComponentInstance"
			end
		end
	elsif	flags==5 then
		if y != @yant then
			e1=@orig.clone
			if y>@yant then kk=-1.0 else kk=1.0 end
			bb=(y-@yant).abs
			if bb>5.0 then bb=5.0 end
			pp=kk*bb/100.0
			e1=Geom::Point3d.linear_combination((1.0-pp),@orig,pp, @target)
			transf3 = Geom::Transformation.translation(@orig.vector_to(e1))
			Sketchup.set_status_text("Distance: #{e1.distance(@target)}", SB_PROMPT)
			@orig=e1.clone
			@sels.each do |i|
				i.transform!(transf3) if i.typename == "ComponentInstance"
			end
			@yant=y
		end
	end
	end # onMouseMove

def drawVetor(orig,vetor)
	v2=vetor.clone
	v2.length = 50.0 
	pt2=orig.transform(Geom::Transformation.translation(v2))
	Sketchup.active_model.active_entities.add_line(orig,pt2)
	end


def draw(view)
	@ip1.draw(view)
	end

end # class Test1

def t2
	myTool=Sketchup.active_model.select_tool(Test2.new)
	end

if not file_loaded?("CompoOOT.rb")
	cmd = UI::Command.new("Mama12") { t2 }
	cmd.small_icon = "OOT_icons/Compo_OOT_16.png"
	cmd.large_icon = "OOT_icons/Compo_OOT_24.png"
	cmd.menu_text = "Mama menu text"

	cmd.tooltip = "Component OrbitOnTarget: Rotate and Distanciate"
	cmd.status_bar_text = "Component OrbitOnTarget: Rotate and Distanciate Selected Component(s) around a Target"
	mamaBar = UI::Toolbar.new("MamaTools")
	mamaBar.add_item(cmd)

	mamaMenu = UI.menu("Plugins")
	mamaSubMenu = mamaMenu.add_submenu("MamaMenus")
	mamaSubMenu.add_item("t2") { t2 }
end
file_loaded("CompoOOT.rb")